## openscenegraph 3.0.1

=== OpenSceneGraph/CMakeLists.txt ===
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

IF(WIN32)
    CMAKE_MINIMUM_REQUIRED(VERSION 2.4.6 FATAL_ERROR)
ELSE(WIN32)
    IF(APPLE)
        CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0 FATAL_ERROR)
    ELSE(APPLE)
        CMAKE_MINIMUM_REQUIRED(VERSION 2.4.4 FATAL_ERROR)
    ENDIF(APPLE)
ENDIF(WIN32)

if(COMMAND cmake_policy)
    # Works around warnings libraries linked against that don't
    # have absolute paths (e.g. -lpthreads)
    cmake_policy(SET CMP0003 NEW)

    # Works around warnings about escaped quotes in ADD_DEFINITIONS
    # statements.
    cmake_policy(SET CMP0005 NEW)

    # cmake-2.6.1 introduces policy cmp0008 decide how to treat full path libraries that do not appear to be valid library file names
    # quote from cvslog "Such libraries worked by accident in the VS IDE and Xcode generators in CMake 2.4 and below."
    if(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} GREATER 4 AND ${CMAKE_PATCH_VERSION} GREATER 0)
        cmake_policy(SET CMP0008 OLD)
    endif()
endif()

PROJECT(OpenSceneGraph)

SET(OPENSCENEGRAPH_MAJOR_VERSION 3)
SET(OPENSCENEGRAPH_MINOR_VERSION 0)
SET(OPENSCENEGRAPH_PATCH_VERSION 1)
SET(OPENSCENEGRAPH_SOVERSION 80)

# set to 0 when not a release candidate, non zero means that any generated 
# svn tags will be treated as release candidates of given number
SET(OPENSCENEGRAPH_RELEASE_CANDIDATE 0)

SET(OPENSCENEGRAPH_VERSION ${OPENSCENEGRAPH_MAJOR_VERSION}.${OPENSCENEGRAPH_MINOR_VERSION}.${OPENSCENEGRAPH_PATCH_VERSION})

SET(OSG_PLUGINS osgPlugins-${OPENSCENEGRAPH_VERSION})

SET(OSG_PLUGIN_PREFIX "")

IF (CYGWIN)
    SET(OSG_PLUGIN_PREFIX "cygwin_")
ENDIF()

IF(MINGW)
    SET(OSG_PLUGIN_PREFIX "mingw_")
ENDIF()


# We want to build SONAMES shared librariess
SET(OPENSCENEGRAPH_SONAMES TRUE)
SET(OPENTHREADS_SONAMES TRUE)

SET(OpenThreads_SOURCE_DIR ${OpenSceneGraph_SOURCE_DIR})

# We have some custom .cmake scripts not in the official distribution.
# Maybe this can be used override existing behavior if needed?
SET(CMAKE_MODULE_PATH "${OpenSceneGraph_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")

## Option to enable Android build using AndroidNDK
OPTION(OSG_BUILD_PLATFORM_ANDROID OFF)
IF(OSG_BUILD_PLATFORM_ANDROID)

    CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0 FATAL_ERROR)

    INCLUDE(OsgAndroidMacroUtils)
    SET(ANDROID TRUE)
    SET(ANDROID_PLATFORM 5)
    FIND_PACKAGE(AndroidNDK REQUIRED)    

    SET(OSG_ANDROID_TEMPLATES "${CMAKE_SOURCE_DIR}/PlatformSpecifics/Android")
    
    SET(J  "4" CACHE STRING "how many processes for make -j <J>")

    ADD_CUSTOM_COMMAND(
        OUTPUT    Android-OpenSceneGraph
        DEPENDS   ${CMAKE_BINARY_DIR}/Android.mk
        COMMAND   "${ANDROID_NDK}/ndk-build" 
        ARGS      --directory=${CMAKE_BINARY_DIR} NDK_APPLICATION_MK=Application.mk -j${J} NDK_LOG=1
    )

    ADD_CUSTOM_TARGET(ndk ALL echo
          DEPENDS Android-OpenSceneGraph
    )
    install(DIRECTORY include/ DESTINATION include/
        PATTERN ".svn" EXCLUDE
    )
    install(DIRECTORY ${CMAKE_BINARY_DIR}/include/ DESTINATION include/
    )
    install(DIRECTORY ${CMAKE_BINARY_DIR}/obj/ DESTINATION obj/
        PATTERN ".svn" EXCLUDE
        PATTERN "objs" EXCLUDE
    )

    ADD_DEFINITIONS(-DANDROID)

ENDIF()



# Okay, here's the problem: On some platforms, linking against OpenThreads
# is not enough and explicit linking to the underlying thread library
# is also required (e.g. FreeBSD). But OpenThreads may be built with different
# backends (Pthreads, Sproc, Windows) so we don't know what the underlying
# thread library is because some platforms support multiple backends (e.g.
# IRIX supports Sproc and Pthreads). Linking all libraries won't work
# because the libraries may be incompatible.
# So the current solution is to attempt best guess linking and exempt certain
# cases. With IRIX, we're going to hope explicit linking to the underlying
# library is not necessary. We currently don't case for pthreads on Windows
# which might be an issue on things like Cygwin. This may need to be fixed.
IF(NOT ANDROID)
    FIND_PACKAGE(Threads)
ENDIF()
IF(CMAKE_SYSTEM MATCHES IRIX)
    # Erase CMAKE_THREAD_LIBS_INIT and hope it works
    SET(CMAKE_THREAD_LIBS_INIT "" CACHE INTERNAL "")
ENDIF()

OPTION(OSG_MAINTAINER "Enable OpenSceneGraph maintainer build methods, such as making svn branches, tags, updating ChangeLog." OFF)
IF (OSG_MAINTAINER)

    #SET(OPENSCENEGRAPH_SVN "trunk")
    SET(OPENSCENEGRAPH_SVN "branches")
    SET(OPENSCENEGRAPH_BRANCH OpenSceneGraph-${OPENSCENEGRAPH_MAJOR_VERSION}.${OPENSCENEGRAPH_MINOR_VERSION})

    #
    # Provide target for tagging a release
    #
    SET(SVNCOMMAND svn)
    SET(SVNTRUNKDIR     http://www.openscenegraph.org/svn/osg/OpenSceneGraph/trunk)
    SET(SVNTAGDIR       http://www.openscenegraph.org/svn/osg/OpenSceneGraph/tags)
    SET(SVNBRANCHDIR    http://www.openscenegraph.org/svn/osg/OpenSceneGraph/branches)

    IF   (OPENSCENEGRAPH_SVN STREQUAL "trunk")
        SET(SVNSOURCEDIR ${SVNTRUNKDIR})
    ELSE()
        SET(SVNSOURCEDIR ${SVNBRANCHDIR}/${OPENSCENEGRAPH_BRANCH})
    ENDIF()


    IF   (OPENSCENEGRAPH_RELEASE_CANDIDATE EQUAL 0)
        SET(RELEASE_NAME OpenSceneGraph-${OPENSCENEGRAPH_VERSION})
    ELSE()
        SET(RELEASE_NAME OpenSceneGraph-${OPENSCENEGRAPH_VERSION}-rc${OPENSCENEGRAPH_RELEASE_CANDIDATE})
    ENDIF()


    ADD_CUSTOM_TARGET(tag-test
        COMMAND echo ${SVNCOMMAND} copy ${SVNSOURCEDIR} ${SVNTAGDIR}/${RELEASE_NAME} -m "Release ${RELEASE_NAME}"
    )

    ADD_CUSTOM_TARGET(tag-run
        COMMAND ${SVNCOMMAND} copy ${SVNSOURCEDIR} ${SVNTAGDIR}/${RELEASE_NAME} -m "Release ${RELEASE_NAME}"
    )

    ADD_CUSTOM_TARGET(branch-test
        COMMAND echo ${SVNCOMMAND} copy ${SVNSOURCEDIR} ${SVNBRANCHDIR}/${OPENSCENEGRAPH_BRANCH} -m "Branch ${OPENSCENEGRAPH_BRANCH}"
    )

    ADD_CUSTOM_TARGET(branch-run
        COMMAND ${SVNCOMMAND} copy ${SVNSOURCEDIR} ${SVNBRANCHDIR}/${OPENSCENEGRAPH_BRANCH} -m "Branch ${OPENSCENEGRAPH_BRANCH}"
    )

    #
    # Provide target for generating ChangeLog
    #
    SET(GENERATELOGS svn2cl)

    ADD_CUSTOM_TARGET(ChangeLog
        COMMAND ${SVNCOMMAND} update
        COMMAND ${GENERATELOGS} ${SVNSOURCEDIR}
    )
    
ENDIF(OSG_MAINTAINER)

IF(NOT ANDROID)
IF(APPLE)
    # Trying to get CMake to generate an XCode IPhone project, current efforts are to get iphoneos sdk 3.1 working
    # Added option which needs manually setting to select the IPhone SDK for building. We can only have one of the below
    # set to true. Should realy have an OSG_BUILD_PLATFORM variable that we set to our desired platform
    OPTION(OSG_BUILD_PLATFORM_IPHONE "Enable IPhoneSDK Device support" OFF)
    OPTION(OSG_BUILD_PLATFORM_IPHONE_SIMULATOR "Enable IPhoneSDK Simulator support" OFF)

    IF(OSG_BUILD_PLATFORM_IPHONE OR OSG_BUILD_PLATFORM_IPHONE_SIMULATOR)

        #you need to manually set the default sdk version here
        SET (IPHONE_SDKVER "3.2")

        #the below is taken from ogre, it states the gcc stuff needs to happen before PROJECT() is called. I've no clue if we even need it
        # Force gcc <= 4.2 on iPhone
        include(CMakeForceCompiler)
        CMAKE_FORCE_C_COMPILER(gcc-4.2 GNU)
        CMAKE_FORCE_CXX_COMPILER(gcc-4.2 GNU)
        SET(GCC_THUMB_SUPPORT NO)

        #set either the device sdk or the simulator sdk. Can't find away to separate these in the same project
        IF(OSG_BUILD_PLATFORM_IPHONE)
            SET (IPHONE_DEVROOT "/Developer/Platforms/iPhoneOS.platform/Developer")
            SET (IPHONE_SDKROOT "${IPHONE_DEVROOT}/SDKs/iPhoneOS${IPHONE_SDKVER}.sdk")
        ELSE()
            SET (IPHONE_DEVROOT "/Developer/Platforms/iPhoneSimulator.platform/Developer")
            SET (IPHONE_SDKROOT "${IPHONE_DEVROOT}/SDKs/iPhoneSimulator${IPHONE_SDKVER}.sdk")
        ENDIF()

        # Apple iOS: Find OpenGLES
        FIND_LIBRARY(OPENGLES_LIBRARY OpenGLES)
    ELSE ()
        FIND_LIBRARY(CARBON_LIBRARY Carbon)
        FIND_LIBRARY(COCOA_LIBRARY Cocoa)

        # Apple OS X: Find OpenGL and AGL
        FIND_PACKAGE(OpenGL)
        FIND_LIBRARY(AGL_LIBRARY AGL)
    ENDIF ()

    OPTION(OSG_COMPILE_FRAMEWORKS "compile frameworks instead of dylibs (experimental)" OFF)
    SET(OSG_COMPILE_FRAMEWORKS_INSTALL_NAME_DIR "@executable_path/../Frameworks" CACHE STRING "install name dir for compiled frameworks")
ELSE()
    # Non-Apple: Find OpenGL
    FIND_PACKAGE(OpenGL)
ENDIF()
ENDIF()

IF(UNIX AND NOT ANDROID)
    # Not sure what this will do on Cygwin and Msys
    # Also, remember OS X X11 is a user installed option so it may not exist.
    FIND_PACKAGE(X11)
    # Some Unicies need explicit linkage to the Math library or the build fails.
    FIND_LIBRARY(MATH_LIBRARY m)

    FIND_LIBRARY(DL_LIBRARY dl)
    IF(NOT DL_LIBRARY)
        SET(DL_LIBRARY "") # change from NOTFOUND to empty when passed to linker
    ENDIF()

    IF( CMAKE_SYSTEM MATCHES "Linux" )
        FIND_LIBRARY( RT_LIBRARY rt )
    ENDIF( CMAKE_SYSTEM MATCHES "Linux" )

ENDIF()

INCLUDE_DIRECTORIES(
    ${OpenSceneGraph_SOURCE_DIR}/include
    ${OPENGL_INCLUDE_DIR}
)

# Make the headers visible to everything
IF(NOT ${PROJECT_BINARY_DIR} EQUAL ${PROJECT_SOURCE_DIR})
   INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include)
ENDIF()

# Common global definitions
#ADD_DEFINITIONS(-D)
# Platform specific definitions


IF(WIN32 AND NOT ANDROID)

    IF(MSVC)
        # This option is to enable the /MP switch for Visual Studio 2005 and above compilers
        OPTION(WIN32_USE_MP "Set to ON to build OpenSceneGraph with the /MP option (Visual Studio 2005 and above)." OFF)
        MARK_AS_ADVANCED(WIN32_USE_MP)
        IF(WIN32_USE_MP)
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
        ENDIF(WIN32_USE_MP)

        # turn off various warnings
        # foreach(warning 4244 4251 4267 4275 4290 4786 4305 4996)
        #     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd${warning}")
        # endforeach(warning)

        # This option is to enable the /DYNAMICBASE switch
        # It is used to workaround a bug in Windows 7 when linking in release, which results in corrupt
        # binaries. See this page for details: http://www.wintellect.com/CS/blogs/jrobbins/archive/2009/01/24/the-case-of-the-corrupt-pe-binaries.aspx
        OPTION(WIN32_USE_DYNAMICBASE "Set to ON to build OpenSceneGraph with the /DYNAMICBASE option to work around a bug when linking release executables on Windows 7." OFF)
        MARK_AS_ADVANCED(WIN32_USE_DYNAMICBASE)
        IF(WIN32_USE_DYNAMICBASE)
            SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /DYNAMICBASE")
        ENDIF(WIN32_USE_DYNAMICBASE)

        # More MSVC specific compilation flags
        ADD_DEFINITIONS(-D_SCL_SECURE_NO_WARNINGS)
        ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)

        OPTION(MSVC_DISABLE_CHECKED_ITERATORS "Set to ON to disable Visual C++ checked iterators. If you do this you must ensure that every other project in your solution and all dependencies are compiled with _SECURE_SCL=0." OFF)
        MARK_AS_ADVANCED(MSVC_DISABLE_CHECKED_ITERATORS)
        IF(MSVC_DISABLE_CHECKED_ITERATORS)
            ADD_DEFINITIONS(-D_SECURE_SCL=0)
        ENDIF(MSVC_DISABLE_CHECKED_ITERATORS)

        OPTION(MSVC_USE_DEFAULT_STACK_SIZE "Set to ON to use the default Visual C++ stack size. CMake forces a high stack size by default, which can cause problems for applications with large number of threads." OFF)
        MARK_AS_ADVANCED(MSVC_USE_DEFAULT_STACK_SIZE)
        IF(MSVC_USE_DEFAULT_STACK_SIZE)
            STRING(REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
            STRING(REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}")
            STRING(REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS}")
        ENDIF(MSVC_USE_DEFAULT_STACK_SIZE)

    ENDIF()

    #needed for net plugin
    SET (OSG_SOCKET_LIBS wsock32)

=== OpenSceneGraph/examples/CMakeLists.txt ===
#######################################################
# this are setting used in SETUP_EXAMPLE macro
#######################################################
SET(TARGET_DEFAULT_PREFIX "example_")
SET(TARGET_DEFAULT_LABEL_PREFIX "Examples")

SET(TARGET_COMMON_LIBRARIES 
    OpenThreads
    osg 
    osgDB 
    osgUtil
    osgGA
    osgViewer 
    osgText 
)

IF(ANDROID)
    # ADD_SUBDIRECTORY(osgandroidsimple)
ELSE(ANDROID)

IF(DYNAMIC_OPENSCENEGRAPH)

    ADD_SUBDIRECTORY(osg2cpp)
    ADD_SUBDIRECTORY(osganalysis)
    ADD_SUBDIRECTORY(osganimate)
    ADD_SUBDIRECTORY(osgautocapture)
    ADD_SUBDIRECTORY(osgautotransform)
    ADD_SUBDIRECTORY(osgbillboard)
    ADD_SUBDIRECTORY(osgblendequation)
    ADD_SUBDIRECTORY(osgcallback)
    ADD_SUBDIRECTORY(osgcamera)
    ADD_SUBDIRECTORY(osgcatch)
    ADD_SUBDIRECTORY(osgclip)
    ADD_SUBDIRECTORY(osgcompositeviewer)
    ADD_SUBDIRECTORY(osgcopy)
    ADD_SUBDIRECTORY(osgcubemap)
    ADD_SUBDIRECTORY(osgdelaunay)
    ADD_SUBDIRECTORY(osgcluster)
    ADD_SUBDIRECTORY(osgdatabaserevisions)
    ADD_SUBDIRECTORY(osgdepthpartition)
    ADD_SUBDIRECTORY(osgdepthpeeling)
    ADD_SUBDIRECTORY(osgdrawinstanced)
    ADD_SUBDIRECTORY(osgdistortion)
    ADD_SUBDIRECTORY(osgfadetext)
    ADD_SUBDIRECTORY(osgfont)
    ADD_SUBDIRECTORY(osgforest)
    ADD_SUBDIRECTORY(osgfxbrowser)
    ADD_SUBDIRECTORY(osgoutline)
    ADD_SUBDIRECTORY(osggameoflife)
    ADD_SUBDIRECTORY(osggeodemo)
    ADD_SUBDIRECTORY(osggeometry)
    ADD_SUBDIRECTORY(osggeometryshaders)
    ADD_SUBDIRECTORY(osghangglide)
    ADD_SUBDIRECTORY(osghud)
    ADD_SUBDIRECTORY(osgimagesequence)
    ADD_SUBDIRECTORY(osgimpostor)
    ADD_SUBDIRECTORY(osgintersection)
    ADD_SUBDIRECTORY(osgkdtree)
    ADD_SUBDIRECTORY(osgkeyboard)
    ADD_SUBDIRECTORY(osgkeyboardmouse)
    ADD_SUBDIRECTORY(osglauncher)
    ADD_SUBDIRECTORY(osglight)
    ADD_SUBDIRECTORY(osglightpoint)
    ADD_SUBDIRECTORY(osglogicop)
    ADD_SUBDIRECTORY(osglogo)
    ADD_SUBDIRECTORY(osggpx)
    ADD_SUBDIRECTORY(osggraphicscost)
    ADD_SUBDIRECTORY(osgmanipulator)
    ADD_SUBDIRECTORY(osgmovie)
    ADD_SUBDIRECTORY(osgmultiplerendertargets)
    ADD_SUBDIRECTORY(osgmultitexture)
    ADD_SUBDIRECTORY(osgmultitexturecontrol)
    ADD_SUBDIRECTORY(osgmultiviewpaging)
    ADD_SUBDIRECTORY(osgoccluder)
    ADD_SUBDIRECTORY(osgocclusionquery)
    ADD_SUBDIRECTORY(osgoit)
    ADD_SUBDIRECTORY(osgpackeddepthstencil)
    ADD_SUBDIRECTORY(osgpagedlod)
    ADD_SUBDIRECTORY(osgparametric)
    ADD_SUBDIRECTORY(osgparticle)
    ADD_SUBDIRECTORY(osgparticleeffects)
    ADD_SUBDIRECTORY(osgparticleshader)
    ADD_SUBDIRECTORY(osgpick)
    ADD_SUBDIRECTORY(osgplanets)
    ADD_SUBDIRECTORY(osgpoints)
    ADD_SUBDIRECTORY(osgpointsprite)
    ADD_SUBDIRECTORY(osgposter)
    ADD_SUBDIRECTORY(osgprecipitation)
    ADD_SUBDIRECTORY(osgprerender)
    ADD_SUBDIRECTORY(osgprerendercubemap)
    ADD_SUBDIRECTORY(osgreflect)
    ADD_SUBDIRECTORY(osgrobot)
    ADD_SUBDIRECTORY(osgscalarbar)
    ADD_SUBDIRECTORY(osgscribe)
    ADD_SUBDIRECTORY(osgsequence)
    ADD_SUBDIRECTORY(osgshaders)
    ADD_SUBDIRECTORY(osgshadercomposition)
    ADD_SUBDIRECTORY(osgshadergen)
    ADD_SUBDIRECTORY(osgshaderterrain)
    # ADD_SUBDIRECTORY(osgshadercompositor)
    ADD_SUBDIRECTORY(osgshadow)
    ADD_SUBDIRECTORY(osgshape)
    ADD_SUBDIRECTORY(osgsharedarray)
    ADD_SUBDIRECTORY(osgsimplifier)
    ADD_SUBDIRECTORY(osgsimulation)
    ADD_SUBDIRECTORY(osgsidebyside)
    ADD_SUBDIRECTORY(osgslice)
    ADD_SUBDIRECTORY(osgspacewarp)
    ADD_SUBDIRECTORY(osgspheresegment)
    ADD_SUBDIRECTORY(osgspotlight)
    ADD_SUBDIRECTORY(osgstereoimage)
    ADD_SUBDIRECTORY(osgstereomatch)
    ADD_SUBDIRECTORY(osgterrain)
    ADD_SUBDIRECTORY(osgthreadedterrain)
    ADD_SUBDIRECTORY(osgtext)
    ADD_SUBDIRECTORY(osgtext3D)
    ADD_SUBDIRECTORY(osgtexture1D)
    ADD_SUBDIRECTORY(osgtexture2D)
    ADD_SUBDIRECTORY(osgtexture3D)
    ADD_SUBDIRECTORY(osgtexturerectangle)
    ADD_SUBDIRECTORY(osgtexturecompression)
    ADD_SUBDIRECTORY(osgthirdpersonview)
    ADD_SUBDIRECTORY(osguniformbuffer)
    ADD_SUBDIRECTORY(osguserstats)
    ADD_SUBDIRECTORY(osgvertexprogram)
    ADD_SUBDIRECTORY(osgvertexattributes)
    ADD_SUBDIRECTORY(osgvolume)
    ADD_SUBDIRECTORY(osgwindows)
    ADD_SUBDIRECTORY(osgvirtualprogram)
    ADD_SUBDIRECTORY(osganimationhardware)
    ADD_SUBDIRECTORY(osganimationtimeline)
    ADD_SUBDIRECTORY(osganimationnode)
    ADD_SUBDIRECTORY(osganimationmakepath)
    ADD_SUBDIRECTORY(osganimationmorph)
    ADD_SUBDIRECTORY(osganimationskinning)
    ADD_SUBDIRECTORY(osganimationsolid)
    ADD_SUBDIRECTORY(osganimationviewer)
    ADD_SUBDIRECTORY(osganimationeasemotion)
    ADD_SUBDIRECTORY(osgwidgetaddremove)
    ADD_SUBDIRECTORY(osgwidgetbox)
    ADD_SUBDIRECTORY(osgwidgetcanvas)
    ADD_SUBDIRECTORY(osgwidgetframe)
    ADD_SUBDIRECTORY(osgwidgetinput)
    ADD_SUBDIRECTORY(osgwidgetlabel)
    ADD_SUBDIRECTORY(osgwidgetmessagebox)
    ADD_SUBDIRECTORY(osgwidgetmenu)
    ADD_SUBDIRECTORY(osgwidgetnotebook)
    ADD_SUBDIRECTORY(osgwidgetperformance)
    ADD_SUBDIRECTORY(osgwidgetscrolled)
    ADD_SUBDIRECTORY(osgwidgetshader)
    ADD_SUBDIRECTORY(osgwidgetstyled)
    ADD_SUBDIRECTORY(osgwidgettable)
    ADD_SUBDIRECTORY(osgwidgetwindow)
    ADD_SUBDIRECTORY(osguserdata)

    IF(OSG_CPP_EXCEPTIONS_AVAILABLE)
        ADD_SUBDIRECTORY(osgunittests)
        ADD_SUBDIRECTORY(osgmemorytest)
    ENDIF()

    IF(NOT OSG_GL3_AVAILABLE)
        ADD_SUBDIRECTORY(osgfpdepth)
    ENDIF()

    IF(NOT OSG_GLES1_AVAILABLE AND NOT OSG_GLES2_AVAILABLE AND NOT OSG_GL3_AVAILABLE)
        ADD_SUBDIRECTORY(osgscreencapture)
        ADD_SUBDIRECTORY(osgmotionblur)
        ADD_SUBDIRECTORY(osgteapot)
    ENDIF()

    ADD_SUBDIRECTORY(osgphotoalbum)
    ADD_SUBDIRECTORY(osgtessellate)

    ADD_SUBDIRECTORY(osgpdf)

    IF   (GLUT_FOUND)
        ADD_SUBDIRECTORY(osgviewerGLUT)
    ENDIF(GLUT_FOUND)

    IF   (SDL_FOUND)
        ADD_SUBDIRECTORY(osgviewerSDL)
    ENDIF(SDL_FOUND)

    IF   (GTKGL_FOUND)
        ADD_SUBDIRECTORY(osgviewerGTK)
    ENDIF(GTKGL_FOUND)

    IF   (FOX_FOUND)
        ADD_SUBDIRECTORY(osgviewerFOX)
    ENDIF(FOX_FOUND)

    IF   (wxWidgets_FOUND)
        ADD_SUBDIRECTORY(osgviewerWX)
    ENDIF(wxWidgets_FOUND)

    IF   (QT_FOUND AND NOT OSG_GLES1_AVAILABLE AND NOT OSG_GLES2_AVAILABLE AND NOT OSG_GL3_AVAILABLE)
        OPTION(BUILD_QT_EXAMPLES "Enable the build of the examples that depend on Qt" ON)

        IF (BUILD_QT_EXAMPLES AND QT_QTOPENGL_LIBRARY)
            ADD_SUBDIRECTORY(osgviewerQt)
            ADD_SUBDIRECTORY(osgqfont)
        ENDIF()

        IF (BUILD_QT_EXAMPLES AND QT4_FOUND AND QT_QTWEBKIT_FOUND)
            ADD_SUBDIRECTORY(osgQtWidgets)
            ADD_SUBDIRECTORY(osgQtBrowser)
        ENDIF()

    ENDIF()

    IF   (FLTK_FOUND)
        ADD_SUBDIRECTORY(osgviewerFLTK)
    ENDIF(FLTK_FOUND)

    IF   (WIN32)

        OPTION(BUILD_MFC_EXAMPLE "Enable the build of the MFC Example" OFF)

        IF   (BUILD_MFC_EXAMPLE)        
            ADD_SUBDIRECTORY(osgviewerMFC)
        ENDIF(BUILD_MFC_EXAMPLE)

    ENDIF(WIN32)

    IF   (APPLE)
        ADD_SUBDIRECTORY(osgviewerCocoa)
    ENDIF(APPLE)

    IF(DIRECTINPUT_FOUND)
       ADD_SUBDIRECTORY(osgdirectinput)
    ENDIF(DIRECTINPUT_FOUND)

    IF   (LIBVNCSERVER_FOUND)
        ADD_SUBDIRECTORY(osgvnc)
    ENDIF(LIBVNCSERVER_FOUND)

    #to add subject to find socket#ADD_SUBDIRECTORY(osgcluster)

ELSE(DYNAMIC_OPENSCENEGRAPH)
    #needed on win32 or the linker get confused by _declspec declarations
    ADD_DEFINITIONS(-DOSG_LIBRARY_STATIC)

    ADD_SUBDIRECTORY(osgstaticviewer)

    # IPHONE_PORT@tom
    IF(OSG_BUILD_PLATFORM_IPHONE OR OSG_BUILD_PLATFORM_IPHONE_SIMULATOR)
        ADD_SUBDIRECTORY(osgviewerIPhone)
    ENDIF()
     # IPHONE_PORT@tom
    
ENDIF(DYNAMIC_OPENSCENEGRAPH)

ENDIF(ANDROID)

=== OpenSceneGraph/src/CMakeLists.txt ===
IF(ANDROID)
    SET(MODULE_USER_STATIC_OR_DYNAMIC ${OPENSCENEGRAPH_USER_DEFINED_DYNAMIC_OR_STATIC})
ENDIF(ANDROID)

IF(MSVC80 OR MSVC90)
  OPTION(OSG_MSVC_GENERATE_PLUGINS_AND_WRAPPERS_MANIFESTS "Generate or not manifests files under VS8 for dynamically loaded dlls" ON)
ENDIF()

#the old construct SUBDIRS( was substituded by ADD_SUBDIRECTORY that is to be preferred according on CMake docs.
FOREACH( mylibfolder 
        OpenThreads
        osg
        osgDB 
        osgUtil 
        osgGA 
        osgText 
        osgViewer
        osgAnimation 
        osgFX
        osgManipulator
        osgParticle
        osgPresentation
        osgShadow
        osgSim
        osgTerrain
        osgWidget
        osgVolume
        osgWrappers/serializers
        osgWrappers/deprecated-dotosg
        osgPlugins
    )

    ADD_SUBDIRECTORY(${mylibfolder})

ENDFOREACH()

IF (QT4_FOUND AND NOT ANDROID)
    ADD_SUBDIRECTORY(osgQt)
ENDIF()

IF(ANDROID)
    configure_file("${OSG_ANDROID_TEMPLATES}/Android.mk.src.in" "${CMAKE_CURRENT_BINARY_DIR}/Android.mk")
ENDIF()

=== OpenSceneGraph/examples/osgQtBrowser/CMakeLists.txt ===
SET(TARGET_SRC
    osgQtBrowser.cpp
)

IF(CMAKE_COMPILER_IS_GNUCXX)
    # Remove -pedantic flag as it barfs on Qt headers
   STRING(REGEX REPLACE "-pedantic" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
ENDIF()

SET(TARGET_EXTERNAL_LIBRARIES ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} ${QT_QTOPENGL_LIBRARY} ${QT_QTWEBKIT_LIBRARY})
INCLUDE_DIRECTORIES(${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR})

SET(TARGET_ADDED_LIBRARIES osgWidget osgQt)

#### end var setup  ###
SETUP_EXAMPLE(osgQtBrowser)

=== OpenSceneGraph/examples/osgQtWidgets/CMakeLists.txt ===
SET(TARGET_SRC
    osgQtWidgets.cpp
)

IF(CMAKE_COMPILER_IS_GNUCXX)
    # Remove -pedantic flag as it barfs on Qt headers
   STRING(REGEX REPLACE "-pedantic" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
ENDIF()

SET(TARGET_EXTERNAL_LIBRARIES ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} ${QT_QTOPENGL_LIBRARY} ${QT_QTWEBKIT_LIBRARY})
INCLUDE_DIRECTORIES(${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR})

SET(TARGET_ADDED_LIBRARIES osgWidget osgQt)

#### end var setup  ###
SETUP_EXAMPLE(osgQtWidgets)

=== OpenSceneGraph/examples/osgqfont/CMakeLists.txt ===
#this file is automatically generated 

INCLUDE_DIRECTORIES( ${QT_INCLUDE_DIR} )
ADD_DEFINITIONS(-DUSE_QT4)

SET(TARGET_SRC osgqfont.cpp )
SET(TARGET_ADDED_LIBRARIES osgQt osgText)
SET(TARGET_EXTERNAL_LIBRARIES ${QT_QTCORE_LIBRARY_RELEASE} ${QT_QTGUI_LIBRARY_RELEASE} ${QT_QTOPENGL_LIBRARY_RELEASE} )

#### end var setup  ###
SETUP_EXAMPLE(osgqfont)

=== OpenSceneGraph/examples/osgviewerQt/CMakeLists.txt ===
SET( TARGET_SRC
    osgviewerQt.cpp
)

IF( QT4_FOUND )
    SET(TARGET_EXTERNAL_LIBRARIES ${QT_QTCORE_LIBRARY_RELEASE} ${QT_QTGUI_LIBRARY_RELEASE} ${QT_QTOPENGL_LIBRARY_RELEASE} )
    ADD_DEFINITIONS(-DUSE_QT4)
ELSE( QT4_FOUND )
    SET(TARGET_EXTERNAL_LIBRARIES ${QT_LIBRARIES} )
ENDIF( QT4_FOUND )

INCLUDE_DIRECTORIES( ${QT_INCLUDE_DIR} )

SET(TARGET_ADDED_LIBRARIES osgWidget osgQt)

SETUP_EXAMPLE( osgviewerQt )

=== OpenSceneGraph/src/OpenThreads/CMakeLists.txt ===
# This is mainly for Windows declspec, but other platforms know
# what to do with it.
ADD_DEFINITIONS(-DOPENTHREADS_EXPORTS)

SET(OPENTHREADS_MAJOR_VERSION 2)
SET(OPENTHREADS_MINOR_VERSION 6)
SET(OPENTHREADS_PATCH_VERSION 0)
SET(OPENTHREADS_SOVERSION 12)

SET(OPENTHREADS_VERSION ${OPENTHREADS_MAJOR_VERSION}.${OPENTHREADS_MINOR_VERSION}.${OPENTHREADS_PATCH_VERSION})

IF(NOT ANDROID)
    INCLUDE(CheckAtomicOps)
ENDIF()

# User Options
OPTION(DYNAMIC_OPENTHREADS "Set to ON to build OpenThreads for dynamic linking.  Use OFF for static." ON)
IF(DYNAMIC_OPENTHREADS)
    SET(OPENTHREADS_USER_DEFINED_DYNAMIC_OR_STATIC "SHARED")
ELSE()
    SET(OPENTHREADS_USER_DEFINED_DYNAMIC_OR_STATIC "STATIC")
    SET(OT_LIBRARY_STATIC 1)
ENDIF()

################################################################################
# Set Config file

SET(OPENTHREADS_CONFIG_HEADER "${PROJECT_BINARY_DIR}/include/OpenThreads/Config")
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/common/Config.in"
               "${OPENTHREADS_CONFIG_HEADER}")

SET(OPENTHREADS_VERSION_HEADER "${PROJECT_SOURCE_DIR}/include/OpenThreads/Version")
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/common/Version.in"
               "${OPENTHREADS_VERSION_HEADER}")


################################################################################
# Set Version Info resource file

IF(MSVC)
    SET(OPENTHREADS_VERSIONINFO_RC "${PROJECT_BINARY_DIR}/PlatformSpecifics/Windows/OpenThreadsVersionInfo.rc")
    CONFIGURE_FILE("${PROJECT_SOURCE_DIR}/PlatformSpecifics/Windows/OpenThreadsVersionInfo.rc.in"
                   "${OPENTHREADS_VERSIONINFO_RC}")
ENDIF()


# INSTALL_FILES(/include/OpenThreads/ FILES "${OPENTHREADS_CONFIG_HEADER}")

################################################################################

SET(HEADER_PATH ${OpenThreads_SOURCE_DIR}/include/OpenThreads)
SET(OpenThreads_PUBLIC_HEADERS
    ${HEADER_PATH}/Atomic
    ${HEADER_PATH}/Barrier
    ${HEADER_PATH}/Block
    ${HEADER_PATH}/Condition
    ${HEADER_PATH}/Exports
    ${HEADER_PATH}/Mutex  
    ${HEADER_PATH}/ReadWriteMutex  
    ${HEADER_PATH}/ReentrantMutex  
    ${HEADER_PATH}/ScopedLock  
    ${HEADER_PATH}/Thread
    ${HEADER_PATH}/Version
    ${OPENTHREADS_CONFIG_HEADER}
)

IF(NOT ANDROID)
# Use our modified version of FindThreads.cmake which has Sproc hacks.
    FIND_PACKAGE(Threads)
ENDIF()
# Do we have sproc?
IF(CMAKE_SYSTEM MATCHES IRIX)
    IF(CMAKE_USE_SPROC_INIT)
        # In this case, only Sproc exists, so no option.
        SET(OPENTHREADS_USE_SPROC_INSTEAD_OF_PTHREADS 1)
    ELSE()
        IF(CMAKE_HAVE_SPROC_H)
            OPTION(OPENTHREADS_USE_SPROC_INSTEAD_OF_PTHREADS "Set to ON to build OpenThreads against sproc instead of pthreads" OFF)
        ENDIF()
    ENDIF()
ENDIF(CMAKE_SYSTEM MATCHES IRIX)

# Add support for using Qt threads
IF(QT4_FOUND)
    OPTION(BUILD_OPENTHREADS_WITH_QT "Build OpenThreads with Qt threading support." OFF)
ENDIF()

# Maybe we should be using the FindThreads.cmake module?
IF(ANDROID)
    SUBDIRS(pthreads)
ELSEIF(QT4_FOUND AND BUILD_OPENTHREADS_WITH_QT)
    SUBDIRS(qt)
ELSEIF(WIN32)
    # So I think Cygwin wants to use pthreads
    IF(CYGWIN)
        SUBDIRS(pthreads)
    ELSE()
        # Everybody else including Msys should probably go here
        SUBDIRS(win32) 
        # examples)
    ENDIF()
ELSE()
    IF(UNIX)
        IF(OPENTHREADS_USE_SPROC_INSTEAD_OF_PTHREADS)
            SUBDIRS(sproc)
        ELSE()
            SUBDIRS(pthreads)
        ENDIF()
    ELSE()
        MESSAGE("Sorry, OpenThreads may not support your platform")
    ENDIF()
ENDIF()

# Make sure everyone can find Config
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include)

# Generate pkg-config configuration file

CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/packaging/pkgconfig/openthreads.pc.in
        ${PROJECT_BINARY_DIR}/packaging/pkgconfig/openthreads.pc
    @ONLY
    )

INSTALL(FILES ${PROJECT_BINARY_DIR}/packaging/pkgconfig/openthreads.pc DESTINATION lib${LIB_POSTFIX}/pkgconfig  COMPONENT libopenthreads-dev)

=== OpenSceneGraph/src/osg/CMakeLists.txt ===

# FIXME: For OS X, need flag for Framework or dylib
IF(DYNAMIC_OPENSCENEGRAPH)
    ADD_DEFINITIONS(-DOSG_LIBRARY)
ELSE()
    ADD_DEFINITIONS(-DOSG_LIBRARY_STATIC)
ENDIF()

SET(LIB_NAME osg)

#
# Enable workaround for OpenGL driver crash with occlusion query
#
OPTION(OSG_FORCE_QUERY_RESULT_AVAILABLE_BEFORE_RETRIEVAL "Set to ON to build OcclussionQueryNode with a workaround for multi-threaded OpenGL driver occlussion query crash. " OFF)
IF(OSG_FORCE_QUERY_RESULT_AVAILABLE_BEFORE_RETRIEVAL)
    ADD_DEFINITIONS(-DFORCE_QUERY_RESULT_AVAILABLE_BEFORE_RETRIEVAL)
ENDIF()


SET(HEADER_PATH ${OpenSceneGraph_SOURCE_DIR}/include/${LIB_NAME})
SET(TARGET_H
    ${HEADER_PATH}/AlphaFunc
    ${HEADER_PATH}/AnimationPath
    ${HEADER_PATH}/ApplicationUsage
    ${HEADER_PATH}/ArgumentParser
    ${HEADER_PATH}/Array
    ${HEADER_PATH}/ArrayDispatchers
    ${HEADER_PATH}/AudioStream
    ${HEADER_PATH}/AutoTransform
    ${HEADER_PATH}/Billboard
    ${HEADER_PATH}/BlendColor
    ${HEADER_PATH}/BlendEquation
    ${HEADER_PATH}/BlendFunc
    ${HEADER_PATH}/BoundingBox
    ${HEADER_PATH}/BoundingSphere
    ${HEADER_PATH}/BoundsChecking
    ${HEADER_PATH}/buffered_value
    ${HEADER_PATH}/BufferIndexBinding
    ${HEADER_PATH}/BufferObject
    ${HEADER_PATH}/Camera
    ${HEADER_PATH}/CameraNode
    ${HEADER_PATH}/CameraView
    ${HEADER_PATH}/ClampColor
    ${HEADER_PATH}/ClearNode
    ${HEADER_PATH}/ClipNode
    ${HEADER_PATH}/ClipPlane
    ${HEADER_PATH}/ClusterCullingCallback
    ${HEADER_PATH}/CollectOccludersVisitor
    ${HEADER_PATH}/ColorMask
    ${HEADER_PATH}/ColorMatrix
    ${HEADER_PATH}/ComputeBoundsVisitor
    ${HEADER_PATH}/ConvexPlanarOccluder
    ${HEADER_PATH}/ConvexPlanarPolygon
    ${HEADER_PATH}/CoordinateSystemNode
    ${HEADER_PATH}/CopyOp
    ${HEADER_PATH}/CullFace
    ${HEADER_PATH}/CullingSet
    ${HEADER_PATH}/CullSettings
    ${HEADER_PATH}/CullStack
    ${HEADER_PATH}/DeleteHandler
    ${HEADER_PATH}/Depth
    ${HEADER_PATH}/DisplaySettings
    ${HEADER_PATH}/Drawable
    ${HEADER_PATH}/DrawPixels
    ${HEADER_PATH}/Endian
    ${HEADER_PATH}/Export
    ${HEADER_PATH}/fast_back_stack
    ${HEADER_PATH}/Fog
    ${HEADER_PATH}/FragmentProgram
    ${HEADER_PATH}/FrameBufferObject
    ${HEADER_PATH}/FrameStamp
    ${HEADER_PATH}/FrontFace
    ${HEADER_PATH}/Geode
    ${HEADER_PATH}/Geometry
    ${HEADER_PATH}/GL
    ${HEADER_PATH}/GL2Extensions
    ${HEADER_PATH}/GLExtensions
    ${HEADER_PATH}/GLBeginEndAdapter
    ${HEADER_PATH}/GLObjects
    ${HEADER_PATH}/GLU
    ${HEADER_PATH}/GraphicsCostEstimator
    ${HEADER_PATH}/GraphicsContext
    ${HEADER_PATH}/GraphicsThread
    ${HEADER_PATH}/Group
    ${HEADER_PATH}/Hint
    ${HEADER_PATH}/Image
    ${HEADER_PATH}/ImageSequence
    ${HEADER_PATH}/ImageStream
    ${HEADER_PATH}/ImageUtils
    ${HEADER_PATH}/io_utils
    ${HEADER_PATH}/KdTree
    ${HEADER_PATH}/Light
    ${HEADER_PATH}/LightModel
    ${HEADER_PATH}/LightSource
    ${HEADER_PATH}/LineSegment
    ${HEADER_PATH}/LineStipple
    ${HEADER_PATH}/LineWidth
    ${HEADER_PATH}/LOD
    ${HEADER_PATH}/LogicOp
    ${HEADER_PATH}/Material
    ${HEADER_PATH}/Math
    ${HEADER_PATH}/Matrix
    ${HEADER_PATH}/Matrixd
    ${HEADER_PATH}/Matrixf
    ${HEADER_PATH}/MatrixTransform
    ${HEADER_PATH}/MixinVector
    ${HEADER_PATH}/Multisample
    ${HEADER_PATH}/Node
    ${HEADER_PATH}/NodeCallback
    ${HEADER_PATH}/NodeTrackerCallback
    ${HEADER_PATH}/NodeVisitor
    ${HEADER_PATH}/Notify
    ${HEADER_PATH}/Object
    ${HEADER_PATH}/observer_ptr
    ${HEADER_PATH}/Observer
    ${HEADER_PATH}/ObserverNodePath
    ${HEADER_PATH}/OccluderNode
    ${HEADER_PATH}/OcclusionQueryNode
    ${HEADER_PATH}/OperationThread
    ${HEADER_PATH}/PagedLOD
    ${HEADER_PATH}/Plane
    ${HEADER_PATH}/Point
    ${HEADER_PATH}/PointSprite
    ${HEADER_PATH}/PolygonMode
    ${HEADER_PATH}/PolygonOffset
    ${HEADER_PATH}/PolygonStipple
    ${HEADER_PATH}/Polytope
    ${HEADER_PATH}/PositionAttitudeTransform
    ${HEADER_PATH}/PrimitiveSet
    ${HEADER_PATH}/Program
    ${HEADER_PATH}/Projection
    ${HEADER_PATH}/ProxyNode
    ${HEADER_PATH}/Quat
    ${HEADER_PATH}/Referenced
    ${HEADER_PATH}/ref_ptr
    ${HEADER_PATH}/RenderInfo
    ${HEADER_PATH}/Scissor
    ${HEADER_PATH}/Sequence
    ${HEADER_PATH}/ShadeModel
    ${HEADER_PATH}/Shader
    ${HEADER_PATH}/ShaderAttribute
    ${HEADER_PATH}/ShaderComposer
    ${HEADER_PATH}/ShadowVolumeOccluder
    ${HEADER_PATH}/Shape
    ${HEADER_PATH}/ShapeDrawable
    ${HEADER_PATH}/State
    ${HEADER_PATH}/StateAttribute
    ${HEADER_PATH}/StateAttributeCallback
    ${HEADER_PATH}/StateSet
    ${HEADER_PATH}/Stats
    ${HEADER_PATH}/Stencil
    ${HEADER_PATH}/StencilTwoSided
    ${HEADER_PATH}/Switch
    ${HEADER_PATH}/TemplatePrimitiveFunctor
    ${HEADER_PATH}/TexEnv
    ${HEADER_PATH}/TexEnvCombine
    ${HEADER_PATH}/TexEnvFilter
    ${HEADER_PATH}/TexGen
    ${HEADER_PATH}/TexGenNode
    ${HEADER_PATH}/TexMat
    ${HEADER_PATH}/Texture
    ${HEADER_PATH}/Texture1D
    ${HEADER_PATH}/Texture2D
    ${HEADER_PATH}/Texture2DMultisample
    ${HEADER_PATH}/Texture2DArray
    ${HEADER_PATH}/Texture3D
    ${HEADER_PATH}/TextureCubeMap
    ${HEADER_PATH}/TextureRectangle
    ${HEADER_PATH}/Timer
    ${HEADER_PATH}/TransferFunction
    ${HEADER_PATH}/Transform
    ${HEADER_PATH}/TriangleFunctor
    ${HEADER_PATH}/TriangleIndexFunctor
    ${HEADER_PATH}/Uniform
    ${HEADER_PATH}/UserDataContainer
    ${HEADER_PATH}/ValueObject
    ${HEADER_PATH}/Vec2
    ${HEADER_PATH}/Vec2b
    ${HEADER_PATH}/Vec2d
    ${HEADER_PATH}/Vec2f
    ${HEADER_PATH}/Vec2s
    ${HEADER_PATH}/Vec3
    ${HEADER_PATH}/Vec3b
    ${HEADER_PATH}/Vec3d
    ${HEADER_PATH}/Vec3f
    ${HEADER_PATH}/Vec3s
    ${HEADER_PATH}/Vec4
    ${HEADER_PATH}/Vec4b
    ${HEADER_PATH}/Vec4d
    ${HEADER_PATH}/Vec4f
    ${HEADER_PATH}/Vec4s
    ${HEADER_PATH}/Vec4ub
    ${HEADER_PATH}/Version
    ${HEADER_PATH}/VertexProgram
    ${HEADER_PATH}/View
    ${HEADER_PATH}/Viewport
    ${OPENSCENEGRAPH_CONFIG_HEADER}
)

#ADD_LIBRARY(${LIB_NAME}
#    ${OPENSCENEGRAPH_USER_DEFINED_DYNAMIC_OR_STATIC}
#    ${LIB_PUBLIC_HEADERS}
SET(TARGET_SRC
    AlphaFunc.cpp
    AnimationPath.cpp
    ApplicationUsage.cpp
    ArgumentParser.cpp
    Array.cpp
    ArrayDispatchers.cpp
    AudioStream.cpp
    AutoTransform.cpp
    Billboard.cpp
    BlendColor.cpp
    BlendEquation.cpp
    BlendFunc.cpp
    BufferIndexBinding.cpp
    BufferObject.cpp
    Camera.cpp
    CameraView.cpp
    ClampColor.cpp
    ClearNode.cpp
    ClipNode.cpp
    ClipPlane.cpp
    ClusterCullingCallback.cpp
    CollectOccludersVisitor.cpp
    ColorMask.cpp
    ColorMatrix.cpp
    ComputeBoundsVisitor.cpp
    ConvexPlanarOccluder.cpp
    ConvexPlanarPolygon.cpp
    CoordinateSystemNode.cpp
    CopyOp.cpp
    CullFace.cpp
    CullingSet.cpp
    CullSettings.cpp
    CullStack.cpp
    DeleteHandler.cpp
    Depth.cpp
    DisplaySettings.cpp
    Drawable.cpp
    DrawPixels.cpp
    dxtctool.cpp
    dxtctool.h
    Fog.cpp
    FragmentProgram.cpp
    FrameBufferObject.cpp
    FrameStamp.cpp
    FrontFace.cpp
    Geode.cpp
    Geometry.cpp
    GL2Extensions.cpp
    GLExtensions.cpp
    GLBeginEndAdapter.cpp
    GLObjects.cpp
    GLStaticLibrary.h
    GLStaticLibrary.cpp
    GraphicsCostEstimator.cpp
    GraphicsContext.cpp
    GraphicsThread.cpp
    Group.cpp
    Hint.cpp
    Image.cpp
    ImageSequence.cpp
    ImageStream.cpp
    ImageUtils.cpp
    KdTree.cpp
    Light.cpp
    LightModel.cpp
    LightSource.cpp
    LineSegment.cpp
    LineStipple.cpp
    LineWidth.cpp
    LOD.cpp
    LogicOp.cpp
    Material.cpp
    Math.cpp
    Matrixd.cpp
    MatrixDecomposition.cpp
    Matrixf.cpp
    # We don't build this one
    #    Matrix_implementation.cpp
    MatrixTransform.cpp
    Multisample.cpp
    NodeCallback.cpp
    Node.cpp
    NodeTrackerCallback.cpp
    NodeVisitor.cpp
    Notify.cpp
    Object.cpp
    Observer.cpp
    ObserverNodePath.cpp
    OccluderNode.cpp
    OcclusionQueryNode.cpp
    OperationThread.cpp
    PagedLOD.cpp
    Point.cpp
    PointSprite.cpp
    PolygonMode.cpp
    PolygonOffset.cpp
    PolygonStipple.cpp
    PositionAttitudeTransform.cpp
    PrimitiveSet.cpp
    Program.cpp
    Projection.cpp
    ProxyNode.cpp
    Quat.cpp
    Referenced.cpp
    Scissor.cpp
    Sequence.cpp
    ShadeModel.cpp
    Shader.cpp
    ShaderAttribute.cpp
    ShaderComposer.cpp
    ShadowVolumeOccluder.cpp
    Shape.cpp
    ShapeDrawable.cpp
    StateAttribute.cpp
    State.cpp
    StateSet.cpp
    Stats.cpp
    Stencil.cpp
    StencilTwoSided.cpp
    Switch.cpp
    TexEnvCombine.cpp
    TexEnv.cpp
    TexEnvFilter.cpp
    TexGen.cpp
    TexGenNode.cpp
    TexMat.cpp
    Texture1D.cpp
    Texture2DArray.cpp
    Texture2D.cpp
    Texture2DMultisample.cpp
    Texture3D.cpp
    Texture.cpp
    TextureCubeMap.cpp
    TextureRectangle.cpp
    Timer.cpp
    TransferFunction.cpp
    Transform.cpp
    Uniform.cpp
    UserDataContainer.cpp
    Version.cpp
    VertexProgram.cpp
    View.cpp
    Viewport.cpp

    glu/libutil/error.cpp
    glu/libutil/mipmap.cpp

    glu/libtess/normal.cpp
    glu/libtess/memalloc.cpp
    glu/libtess/dict-list.h
    glu/libtess/alg-outline
    glu/libtess/priorityq.cpp
    glu/libtess/normal.h
    glu/libtess/dict.h
    glu/libtess/render.cpp
    glu/libtess/tessmono.h
    glu/libtess/mesh.cpp
    glu/libtess/render.h
    glu/libtess/tessmono.cpp
    glu/libtess/priorityq.h
    glu/libtess/sweep.h
    glu/libtess/priorityq-sort.h
    glu/libtess/sweep.cpp
    glu/libtess/tess.h
    glu/libtess/geom.h
    glu/libtess/memalloc.h
    glu/libtess/dict.cpp
    glu/libtess/priorityq-heap.h
    glu/libtess/geom.cpp
    glu/libtess/tess.cpp
    glu/libtess/mesh.h


    ${OPENSCENEGRAPH_VERSIONINFO_RC}
)
SET(TARGET_LIBRARIES OpenThreads)

SET(TARGET_EXTERNAL_LIBRARIES
    ${CMAKE_THREAD_LIBS_INIT}    
    ${MATH_LIBRARY} 
    ${RT_LIBRARY} 
    ${DL_LIBRARY}
)

#LINK_INTERNAL(${LIB_NAME}     
#    OpenThreads
#)
#LINK_EXTERNAL(${LIB_NAME} ${CMAKE_THREAD_LIBS_INIT}    ${MATH_LIBRARY} ${RT_LIBRARY} ${DL_LIBRARY})
#LINK_CORELIB_DEFAULT(${LIB_NAME} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY} ${RT_LIBRARY} )

#INCLUDE(ModuleInstall OPTIONAL)

SETUP_LIBRARY(${LIB_NAME})

=== OpenSceneGraph/src/osgDB/CMakeLists.txt ===

IF   (DYNAMIC_OPENSCENEGRAPH)

    OPTION(OSG_PLUGIN_SEARCH_INSTALL_DIR_FOR_PLUGINS "Set to ON to have OpenSceneGraph search the configured install directory for plugins." ON)

    ADD_DEFINITIONS(-DOSGDB_LIBRARY)

    IF(OSG_PLUGIN_SEARCH_INSTALL_DIR_FOR_PLUGINS)
        # Add a default plugin search path component
        ADD_DEFINITIONS(-DOSG_DEFAULT_LIBRARY_PATH=${CMAKE_INSTALL_PREFIX}/lib${LIB_POSTFIX}/${OSG_PLUGINS})
    ENDIF()

    # Set the library extension according to what configuration is being built.
    # If the string is empty, don't set the define.
    IF(CMAKE_DEBUG_POSTFIX)
        SET(CMAKE_CXX_FLAGS_DEBUG
            "${CMAKE_CXX_FLAGS_DEBUG} -DOSG_LIBRARY_POSTFIX=${CMAKE_DEBUG_POSTFIX}")
    ENDIF()
    IF(CMAKE_RELEASE_POSTFIX)
        SET(CMAKE_CXX_FLAGS_RELEASE
            "${CMAKE_CXX_FLAGS_RELEASE} -DOSG_LIBRARY_POSTFIX=${CMAKE_RELEASE_POSTFIX}")
    ENDIF()
    IF(CMAKE_RELWITHDEBINFO_POSTFIX)
        SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO
            "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -DOSG_LIBRARY_POSTFIX=${CMAKE_RELWITHDEBINFO_POSTFIX}")
    ENDIF()
    IF(CMAKE_MINSIZEREL_POSTFIX)
        SET(CMAKE_CXX_FLAGS_MINSIZEREL
            "${CMAKE_CXX_FLAGS_MINSIZEREL} -DOSG_LIBRARY_POSTFIX=${CMAKE_MINSIZEREL_POSTFIX}")
    ENDIF()
ELSE ()
    ADD_DEFINITIONS(-DOSG_LIBRARY_STATIC)
ENDIF()

IF (APPLE) 
   IF(OSG_BUILD_PLATFORM_IPHONE OR OSG_BUILD_PLATFORM_IPHONE_SIMULATOR)
     # compile FileUtils.cpp as objective-c++
     SET_SOURCE_FILES_PROPERTIES(FileUtils.cpp
       PROPERTIES COMPILE_FLAGS "-x objective-c++"
     )
   ENDIF()
ENDIF()


SET(LIB_NAME osgDB)
SET(HEADER_PATH ${OpenSceneGraph_SOURCE_DIR}/include/${LIB_NAME})
SET(TARGET_H
    ${HEADER_PATH}/DataTypes
    ${HEADER_PATH}/StreamOperator
    ${HEADER_PATH}/Serializer
    ${HEADER_PATH}/ObjectWrapper
    ${HEADER_PATH}/InputStream
    ${HEADER_PATH}/OutputStream
    ${HEADER_PATH}/Archive
    ${HEADER_PATH}/AuthenticationMap
    ${HEADER_PATH}/Callbacks
    ${HEADER_PATH}/ConvertUTF
    ${HEADER_PATH}/DatabasePager
    ${HEADER_PATH}/DatabaseRevisions
    ${HEADER_PATH}/DotOsgWrapper
    ${HEADER_PATH}/DynamicLibrary
    ${HEADER_PATH}/Export
    ${HEADER_PATH}/ExternalFileWriter
    ${HEADER_PATH}/FileCache
    ${HEADER_PATH}/FileNameUtils
    ${HEADER_PATH}/FileUtils
    ${HEADER_PATH}/fstream
    ${HEADER_PATH}/ImageOptions
    ${HEADER_PATH}/ImagePager
    ${HEADER_PATH}/ImageProcessor
    ${HEADER_PATH}/Input
    ${HEADER_PATH}/Output
    ${HEADER_PATH}/Options
    ${HEADER_PATH}/ParameterOutput
    ${HEADER_PATH}/PluginQuery
    ${HEADER_PATH}/ReaderWriter
    ${HEADER_PATH}/ReadFile
    ${HEADER_PATH}/Registry
    ${HEADER_PATH}/SharedStateManager
    ${HEADER_PATH}/Version
    ${HEADER_PATH}/WriteFile
    ${HEADER_PATH}/XmlParser
)

SET(TARGET_SRC
    ObjectWrapper.cpp
    InputStream.cpp
    OutputStream.cpp
    Compressors.cpp
    Archive.cpp
    AuthenticationMap.cpp
    Callbacks.cpp
    ConvertUTF.cpp
    DatabasePager.cpp
    DatabaseRevisions.cpp
    DotOsgWrapper.cpp
    DynamicLibrary.cpp
    ExternalFileWriter.cpp
    Field.cpp
    FieldReader.cpp
    FieldReaderIterator.cpp
    FileCache.cpp
    FileNameUtils.cpp
    FileUtils.cpp
    fstream.cpp
    ImageOptions.cpp
    ImagePager.cpp
    Input.cpp
    MimeTypes.cpp
    Output.cpp
    Options.cpp
    PluginQuery.cpp
    ReaderWriter.cpp
    ReadFile.cpp
    Registry.cpp
    SharedStateManager.cpp
    Version.cpp
    WriteFile.cpp
    XmlParser.cpp
    ${OPENSCENEGRAPH_VERSIONINFO_RC}
)

IF(APPLE)
    IF(NOT OSG_BUILD_PLATFORM_IPHONE AND NOT OSG_BUILD_PLATFORM_IPHONE_SIMULATOR)
        # Needs CoreFoundation calls and a Carbon function
        SET(OSGDB_PLATFORM_SPECIFIC_LIBRARIES ${CARBON_LIBRARY})
    ENDIF()
 
    SET(OSG_DEFAULT_IMAGE_PLUGIN_FOR_OSX "quicktime" CACHE STRING "standard image plugin for os x, options are quicktime, imageio")

    IF(OSG_DEFAULT_IMAGE_PLUGIN_FOR_OSX STREQUAL "quicktime")
        ADD_DEFINITIONS(-DDARWIN_QUICKTIME)
    ELSE()
        ADD_DEFINITIONS(-DDARWIN_IMAGEIO)
    ENDIF()
ENDIF()

IF(QUICKTIME_FOUND)
    ADD_DEFINITIONS(-DUSE_QUICKTIME)
ENDIF()

IF(XINE_FOUND)
    ADD_DEFINITIONS(-DUSE_XINE)
ENDIF()

IF(INVENTOR_FOUND)
    ADD_DEFINITIONS(-DUSE_INVENTOR)
ENDIF()

IF(OPENVRML_FOUND)
    ADD_DEFINITIONS(-DUSE_VRML)
ENDIF()

IF( ZLIB_FOUND )
    ADD_DEFINITIONS( -DUSE_ZLIB )
    INCLUDE_DIRECTORIES( ${ZLIB_INCLUDE_DIR} )
    SET(COMPRESSION_LIBRARIES ZLIB_LIBRARY)
ENDIF()

ADD_DEFINITIONS(-DOSG_PLUGIN_EXTENSION=${CMAKE_SHARED_MODULE_SUFFIX})

SET(TARGET_LIBRARIES     
    osg
    osgUtil
    OpenThreads
)
SET(TARGET_EXTERNAL_LIBRARIES ${OSGDB_PLATFORM_SPECIFIC_LIBRARIES} ${DL_LIBRARY})
SET(TARGET_LIBRARIES_VARS  ${COMPRESSION_LIBRARIES})

SETUP_LIBRARY(${LIB_NAME})

=== OpenSceneGraph/src/osgGA/CMakeLists.txt ===

IF   (DYNAMIC_OPENSCENEGRAPH)
    ADD_DEFINITIONS(-DOSGGA_LIBRARY)
ELSE (DYNAMIC_OPENSCENEGRAPH)
    ADD_DEFINITIONS(-DOSG_LIBRARY_STATIC)
ENDIF(DYNAMIC_OPENSCENEGRAPH)

SET(LIB_NAME osgGA)
SET(HEADER_PATH ${OpenSceneGraph_SOURCE_DIR}/include/${LIB_NAME})
SET(TARGET_H
    ${HEADER_PATH}/AnimationPathManipulator
    ${HEADER_PATH}/DriveManipulator
    ${HEADER_PATH}/EventQueue
    ${HEADER_PATH}/EventVisitor
    ${HEADER_PATH}/Export
    ${HEADER_PATH}/FirstPersonManipulator
    ${HEADER_PATH}/FlightManipulator
    ${HEADER_PATH}/GUIActionAdapter
    ${HEADER_PATH}/GUIEventAdapter
    ${HEADER_PATH}/GUIEventHandler
    ${HEADER_PATH}/KeySwitchMatrixManipulator
    ${HEADER_PATH}/CameraManipulator
    ${HEADER_PATH}/MultiTouchTrackballManipulator
    ${HEADER_PATH}/NodeTrackerManipulator
    ${HEADER_PATH}/OrbitManipulator
    ${HEADER_PATH}/StandardManipulator
    ${HEADER_PATH}/SphericalManipulator
    ${HEADER_PATH}/StateSetManipulator
    ${HEADER_PATH}/TerrainManipulator
    ${HEADER_PATH}/TrackballManipulator
    ${HEADER_PATH}/UFOManipulator
    ${HEADER_PATH}/Version
    ${HEADER_PATH}/CameraViewSwitchManipulator
)

SET(TARGET_SRC
    AnimationPathManipulator.cpp
    DriveManipulator.cpp
    EventQueue.cpp
    EventVisitor.cpp
    FirstPersonManipulator.cpp
    FlightManipulator.cpp
    GUIEventAdapter.cpp
    GUIEventHandler.cpp
    KeySwitchMatrixManipulator.cpp
    CameraManipulator.cpp
    MultiTouchTrackballManipulator.cpp
    NodeTrackerManipulator.cpp
    OrbitManipulator.cpp
    StandardManipulator.cpp
    SphericalManipulator.cpp
    StateSetManipulator.cpp
    TerrainManipulator.cpp
    TrackballManipulator.cpp
    UFOManipulator.cpp
    Version.cpp
    CameraViewSwitchManipulator.cpp
    ${OPENSCENEGRAPH_VERSIONINFO_RC}
)

SET(TARGET_LIBRARIES
    osgDB
    osgUtil
    osg
    OpenThreads
)

SETUP_LIBRARY(${LIB_NAME})

=== OpenSceneGraph/src/osgPlugins/CMakeLists.txt ===
#---------------------------------------------------
# OSG CMAKE SUPPORT
# (C) by Michael Wagner, mtw@shared-reality.com 2005
# (C) Eric Wing, Luigi Calori and Robert Osfield 2006-2007
#---------------------------------------------------

PROJECT(OSG_PLUGINS_MASTER)

IF(NOT DYNAMIC_OPENSCENEGRAPH)
    ADD_DEFINITIONS(-DOSG_LIBRARY_STATIC)
ENDIF()

IF(NOT MSVC)
    SET(LIBRARY_OUTPUT_PATH "${LIBRARY_OUTPUT_PATH}/${OSG_PLUGINS}")
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${OSG_PLUGINS}")
ENDIF()

SET(CMAKE_SHARED_MODULE_PREFIX ${OSG_PLUGIN_PREFIX})

IF(MSVC80 OR MSVC90)
    IF(NOT OSG_MSVC_GENERATE_PLUGINS_AND_WRAPPERS_MANIFESTS)
        SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} /MANIFEST:NO")
    ENDIF()
ENDIF()

SET(TARGET_DEFAULT_PREFIX "osgdb_")
SET(TARGET_DEFAULT_LABEL_PREFIX "Plugins")
SET(TARGET_COMMON_LIBRARIES
    OpenThreads
    osg
    osgDB
    osgUtil
)

############################################################
#
#  NodeKit/Psudo loader plugins
#
ADD_SUBDIRECTORY(osga)
ADD_SUBDIRECTORY(rot)
ADD_SUBDIRECTORY(scale)
ADD_SUBDIRECTORY(trans)
ADD_SUBDIRECTORY(normals)
ADD_SUBDIRECTORY(revisions)
ADD_SUBDIRECTORY(view)
ADD_SUBDIRECTORY(shadow)
ADD_SUBDIRECTORY(terrain)

############################################################
#
#  Main native plugins
#
ADD_SUBDIRECTORY(osg)
ADD_SUBDIRECTORY(ive)

############################################################
#
#  Viewer plugins
#
ADD_SUBDIRECTORY(cfg)

############################################################
#
#  Shader plugins
#
ADD_SUBDIRECTORY(glsl)

############################################################
#
#  Image plugins
#
ADD_SUBDIRECTORY(rgb)
ADD_SUBDIRECTORY(bmp)
ADD_SUBDIRECTORY(pnm)
ADD_SUBDIRECTORY(dds)
ADD_SUBDIRECTORY(tga)
ADD_SUBDIRECTORY(hdr)
ADD_SUBDIRECTORY(dot)
ADD_SUBDIRECTORY(vtf)

IF(JPEG_FOUND)
    ADD_SUBDIRECTORY(jpeg)
ENDIF()
IF(JASPER_FOUND)
    ADD_SUBDIRECTORY(jp2)
ENDIF()
IF(OPENEXR_FOUND AND ZLIB_FOUND)
    ADD_SUBDIRECTORY(exr)
ENDIF()
IF(GIFLIB_FOUND)
    ADD_SUBDIRECTORY(gif)
ENDIF()
IF(PNG_FOUND)
    ADD_SUBDIRECTORY(png)
ENDIF()
IF(TIFF_FOUND)
    ADD_SUBDIRECTORY(tiff)
ENDIF()
IF(GDAL_FOUND)
    ADD_SUBDIRECTORY(gdal)
    ADD_SUBDIRECTORY(ogr)
ENDIF()


############################################################
#
# 3D Image plugins
#
IF(DCMTK_FOUND AND ZLIB_FOUND)
    ADD_SUBDIRECTORY(dicom)
ELSE()
    IF(ITK_FOUND)
        ADD_SUBDIRECTORY(dicom)
    ENDIF()
ENDIF()

############################################################
#
#  3rd party 3d plugins
#

ADD_SUBDIRECTORY(3dc)

ADD_SUBDIRECTORY(p3d)

IF(CURL_FOUND)
    ADD_SUBDIRECTORY(curl)
ENDIF()

IF(ZLIB_FOUND)
    ADD_SUBDIRECTORY(gz)
ENDIF()

IF(NOT OSG_GLES1_AVAILABLE AND NOT OSG_GLES2_AVAILABLE)
    IF(INVENTOR_FOUND)
        ADD_SUBDIRECTORY(Inventor)
    ENDIF()

    IF(PERFORMER_FOUND)
        ADD_SUBDIRECTORY(pfb)
    ENDIF()
ENDIF()

IF(OPENVRML_FOUND)
    ADD_SUBDIRECTORY(vrml)
ENDIF()

IF(COLLADA_FOUND)
    ADD_SUBDIRECTORY(dae)
ENDIF()

IF(FBX_FOUND)
    ADD_SUBDIRECTORY(fbx)
ENDIF()

ADD_SUBDIRECTORY(lwo)
ADD_SUBDIRECTORY(dw)

ADD_SUBDIRECTORY(bvh)
ADD_SUBDIRECTORY(x)
ADD_SUBDIRECTORY(dxf)
ADD_SUBDIRECTORY(OpenFlight)
# ADD_SUBDIRECTORY(flt)
ADD_SUBDIRECTORY(geo)
ADD_SUBDIRECTORY(obj)

ADD_SUBDIRECTORY(pic)
ADD_SUBDIRECTORY(stl)
IF(NOT ANDROID)
    ADD_SUBDIRECTORY(3ds)
ENDIF()
ADD_SUBDIRECTORY(ac)
ADD_SUBDIRECTORY(pov)

ADD_SUBDIRECTORY(logo)
ADD_SUBDIRECTORY(lws)
ADD_SUBDIRECTORY(md2)
ADD_SUBDIRECTORY(osgtgz)
ADD_SUBDIRECTORY(tgz)

ADD_SUBDIRECTORY(shp)
ADD_SUBDIRECTORY(txf)

ADD_SUBDIRECTORY(bsp)
ADD_SUBDIRECTORY(mdl)

IF(OSG_CPP_EXCEPTIONS_AVAILABLE)
    ADD_SUBDIRECTORY(ply)
    ADD_SUBDIRECTORY(txp)
ENDIF()

IF(XINE_FOUND)
    ADD_SUBDIRECTORY(xine)
ENDIF()

IF(FFMPEG_FOUND)
    ADD_SUBDIRECTORY(ffmpeg)
ENDIF()

IF(DIRECTSHOW_FOUND)
    ADD_SUBDIRECTORY(directshow)
ENDIF()

# IF(OPENAL_FOUND)
#    ADD_SUBDIRECTORY(OpenAL)
# ENDIF()

IF(APPLE AND NOT ANDROID)
    ADD_SUBDIRECTORY(imageio)
ENDIF()

IF(QUICKTIME_FOUND)
    ADD_SUBDIRECTORY(quicktime)
ENDIF()

IF(QTKIT_FOUND)
    ADD_SUBDIRECTORY(QTKit)
ENDIF()

IF(NVTT_FOUND)
    ADD_SUBDIRECTORY(nvtt)
ENDIF()


IF(FREETYPE_FOUND)
    ADD_SUBDIRECTORY(freetype)
ENDIF()

IF (QT4_FOUND)
    ADD_SUBDIRECTORY(qfont)
ENDIF()

IF(ZLIB_FOUND)
    ADD_SUBDIRECTORY(zip)
ENDIF()

IF(RSVG_FOUND)
    ADD_SUBDIRECTORY(svg)
ENDIF()

IF(POPPLER_FOUND)
    ADD_SUBDIRECTORY(pdf)
ENDIF()

IF(LIBVNCSERVER_FOUND)
    ADD_SUBDIRECTORY(vnc)
ENDIF()

ADD_SUBDIRECTORY(pvr)

##########to get all the variables of Cmake
#GET_CMAKE_PROPERTY(MYVARS VARIABLES)
#FOREACH(myvar ${MYVARS})
#    FILE(APPEND ${CMAKE_CURRENT_BINARY_DIR}/AllVariables.txt
#        "${myvar} -->${${myvar}}<-\n"
#    )
#ENDFOREACH(myvar)

=== debian/changelog ===
openscenegraph (3.0.1-4) unstable; urgency=low

  [ Alberto Luaces ]
  * Upgraded standards version to 3.9.3.
  * Append options to LDFLAGS instead of replacing its value.
  * Use of hardening flags for building.
  * Added a manpage for the osgviewerWX executable.
  * Changes in the build prefix in order to fix the pkg-config files
    (Closes: #690878).
  * Removal of unused LINKER_FLAGS variable in debian/rules.

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Thu, 22 Nov 2012 22:07:57 +0000

openscenegraph (3.0.1-3) unstable; urgency=low

  * Depend on libpng-dev instead of libpng12-dev for libpng15-transition
    (Closes: #662455)
  * Reformat dependencies in debian/control to show one per line, I think that
    subsequent changes will be much more clear from now on

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Wed, 14 Mar 2012 11:18:59 +0000

openscenegraph (3.0.1-2) unstable; urgency=low

  [ Alberto Luaces ]
  * Fixed ffmpeg FTBFS with 0.8 version (Closes: #654233).

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sun, 08 Jan 2012 19:38:17 +0000

openscenegraph (3.0.1-1) unstable; urgency=low

  * New upstream fixes release.
  * Fixed ffmpeg FTBFS (Closes: #640339).

 -- Loic Dachary (OuoU) <loic@debian.org>  Thu, 08 Sep 2011 16:06:16 +0200

=== debian/control ===
Source: openscenegraph
Section: devel
Priority: optional
Maintainer: Loic Dachary (OuoU) <loic@debian.org>
Uploaders: Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>, Alberto Luaces <aluaces@udc.es>, Ola Lundqvist <opal@debian.org>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7.0.0),
               dpkg-dev (>= 1.16.1~),
               cmake,
               g++ (>= 3.3.0),
               ccache,
               doxygen,
               libgif-dev,
               libjpeg-dev,
               libtiff-dev,
               lib3ds-dev,
               libfreetype6-dev,
               libpng-dev,
               libcoin60-dev,
               libjasper-dev,
               libgdal-dev,
               libx11-dev,
               libxmu-dev,
               freeglut3-dev,
               libgl1-mesa-dev | libgl-dev,
               libxine-dev,
               libavcodec-dev,
               libswscale-dev,
               libavdevice-dev,
               libqt4-dev,
               libqt4-opengl-dev,
               librsvg2-dev,
               libpoppler-glib-dev
Standards-Version: 3.9.3
Homepage: http://www.openscenegraph.org/
Vcs-Git: https://alioth.debian.org/anonscm/git/pkg-osg/pkg-osg.git
Vcs-Browser: https://alioth.debian.org/scm/browser.php?group_id=100578

Package: libopenthreads-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libopenthreads14 (= ${binary:Version})
Description: Object-Oriented (OO) thread interface for C++, development files
 This library is intended to provide a minimal & complete Object-Oriented (OO)
 thread interface for C++ programmers, used primarily in OpenSceneGraph.  It is
 loosely modeled on the Java thread API, and the POSIX Threads standards.
 .
 This package contains the development headers.

Package: libopenthreads14
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: libopenthreads,
           libopenthreads2,
           libopenthreads3,
           libopenthreads1c2,
           libopenthreads11
Description: Object-Oriented (OO) thread interface for C++, shared libs
 This library is intended to provide a minimal & complete Object-Oriented (OO)
 thread interface for C++ programmers, used primarily in OpenSceneGraph.  It is
 loosely modeled on the Java thread API, and the POSIX Threads standards.
 .
 This package contains the shared libraries.

Package: libopenscenegraph-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libopenthreads-dev,
         libgl1-mesa-dev | libgl-dev,
         libglu-dev,
         libopenscenegraph80 (= ${binary:Version})
Suggests: openscenegraph-doc,
          openscenegraph-examples
Description: 3D scene graph, development files
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains the development headers.

Package: libopenscenegraph80
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: libopenscenegraph,
           libopenscenegraph2,
           libopenscenegraph3,
           libopenscenegraph1c2,
           libopenscenegraph7,
           libopenscenegraph55
Description: 3D scene graph, shared libs
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains the shared libraries.

Package: openscenegraph-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: 3D scene graph, documentation
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains the documentation.

Package: openscenegraph
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D scene graph, utilities and examples (binaries)
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains utilities and examples (binaries).

Package: openscenegraph-examples
Architecture: all
Depends: ${misc:Depends}
Description: 3D scene graph, examples (sources)
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains examples (sources).

=== debian/rules ===
#!/usr/bin/make -f
# # Sample debian/rules that uses debhelper.
# # GNU copyright 1997 to 1999 by Joey Hess.
# #
# # Build comments:
# #  About 3.2 GB is needed on disc.
# #  orig sources are created by
# #    mkdir openscenegraph-xxx.orig
# #    cd openscenegraph-xxx.orig
# #    unzip OpenSceneGraph-xxx.zip
# #    mv OpenSceneGraph-xxx OpenSceneGraph
# #    cd ..
# #    cp -a openscenegraph-xxx.orig openscenegraph-xxx
# #    cd openscenegraph-xxx
# #    cp -a ../openscenegraph-yyy/debian .
# 
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# At the moment, CMake discards CPPFLAGS, so we have to add its value
# to C{,XX}FLAGS variables

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

%:
	dh  $@

# Use override_dh_* targets to customize this.

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif
# Default to g++
CXX ?= g++

# Detect parallel builds.
ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
    PARALLEL_JOBS = $(shell echo $(DEB_BUILD_OPTIONS) | \
        sed -e 's/.*parallel=\([0-9]\+\).*/\1/')
    PARALLEL_OPTIONS = -j$(PARALLEL_JOBS)
endif

define SETAFFINITY
	grep 'sched_setaffinity.*cpusetsize' /usr/include/sched.h > /dev/null || export COMPILE_USING_TWO_PARAM_sched_setaffinity=-DCOMPILE_USING_TWO_PARAM_sched_setaffinity ; 
endef

OSG = OpenSceneGraph

ifeq (hppa,$(DEB_BUILD_ARCH))
ARCH_C_FLAGS=-mlong-calls
ARCH_CXX_FLAGS=${ARCH_C_FLAGS}
endif

CFLAGS := ${CFLAGS} ${ARCH_C_FLAGS}
CXXFLAGS := ${CXXFLAGS} ${ARCH_CXX_FLAGS}

LDFLAGS += -Wl,--as-needed

#
# Shared libraries version numbers
#
# OpenSceneGraph/OpenThreads/Producer 0.9.8
#
#OPENSCENEGRAPH_SOVERSION=0
#
# OpenSceneGraph/OpenThreads/Producer 0.9.9
#
#OPENSCENEGRAPH_SOVERSION=1
#
# OpenSceneGraph/OpenThreads/Producer 1.0
#
#OPENSCENEGRAPH_SOVERSION=2
#
# OpenSceneGraph/OpenThreads/Producer 1.1
#
#OPENSCENEGRAPH_SOVERSION=3
#
# OpenSceneGraph/OpenThreads/Producer 1.2
#
#OPENSCENEGRAPH_SOVERSION=4
#
# OpenSceneGraph-1.9.1/OpenThreads-1.9.3 overriden with
# OpenSceneGraph-1.9.3, OpenSceneGraph-1.9.4, OpenSceneGraph-1.9.5, OpenSceneGraph-1.9.7 and
# OpenSceneGraph-2.0.0
#
#OPENSCENEGRAPH_SOVERSION=5
#
# OpenSceneGraph 2.2.0
#
#
#OPENSCENEGRAPH_SOVERSION=6
#
# OpenSceneGraph 2.4.0
#
#OPENSCENEGRAPH_SOVERSION=7
#OSG_VERSION=2.4.0
#
# OpenSceneGraph 2.6.1
#
#OPENSCENEGRAPH_SOVERSION=48
#OSG_VERSION=2.6.1
#
# OpenSceneGraph 2.8.0
#
#OPENSCENEGRAPH_SOVERSION=55
#OSG_VERSION=2.8.0
#
# OpenSceneGraph 2.8.1 and .2
#
#OPENTHREADS_SOVERSION=12
#OPENSCENEGRAPH_SOVERSION=56
#
# OpenSceneGraph 2.8.3
# OPENTHREADS_SOVERSION=13
# OPENSCENEGRAPH_SOVERSION=65
#
# OpenSceneGraph 2.9.10
# OPENTHREADS_SOVERSION=14
# OPENSCENEGRAPH_SOVERSION=68
#
# OpenSceneGraph 2.9.11
# OPENTHREADS_SOVERSION=14
# OPENSCENEGRAPH_SOVERSION=71
#
# OpenSceneGraph 2.9.13
# OPENTHREADS_SOVERSION=14
# OPENSCENEGRAPH_SOVERSION=73
#
# OpenSceneGraph 2.9.14
# OPENTHREADS_SOVERSION=14
# OPENSCENEGRAPH_SOVERSION=75
#
# OpenSceneGraph 2.9.16
# OPENTHREADS_SOVERSION=14
# OPENSCENEGRAPH_SOVERSION=77
#
# OpenSceneGraph 3.0.0
OPENTHREADS_SOVERSION=14
OPENSCENEGRAPH_SOVERSION=80

GRAB_VERSION_COMMAND := sed -n '1s~[^(]*(\(.*\)-.*).*~\1~p' debian/changelog
VERSION := $(shell $(GRAB_VERSION_COMMAND))
TMPDIR := $(shell mktemp -d)
TARBALL_NAME := openscenegraph_$(VERSION).orig.tar.gz
UPSTREAM_SVN_TAG_DIR := http://www.openscenegraph.org/svn/osg/OpenSceneGraph/tags/OpenSceneGraph

get-orig-source:
	dh_testdir
	mkdir -p $(TMPDIR)/openscenegraph-$(VERSION)
	svn export $(UPSTREAM_SVN_TAG_DIR)-$(VERSION) $(TMPDIR)/openscenegraph-$(VERSION)/$(OSG)
	tar czvf ../$(TARBALL_NAME) -C $(TMPDIR)/ openscenegraph-$(VERSION)
	rm -rf $(TMPDIR)

clean:
	dh_testdir
	dh_testroot

	# Add here commands to clean up after the build process.
	rm -fr build
	rm -f ${MANPAGES} 
	rm -fr html

	dh_clean 

MANPAGES = \
	${MANAPPLICATIONS} \
	${MANEXAMPLES}

MANAPPLICATIONS = \
	osgviewer.1 \
	osgconv.1 \
	osgversion.1 \
	osgfilecache.1 \
	osgarchive.1

MANEXAMPLES = \
	osg2cpp.1 \
	osganimate.1 \
	osganimationhardware.1 \
	osganimationmakepath.1 \
	osganimationnode.1 \
	osganimationskinning.1 \
	osganimationsolid.1 \
	osganimationtimeline.1 \
	osganimationviewer.1 \
	osgautocapture.1 \
	osgautotransform.1 \
	osgbillboard.1 \
	osgblendequation.1 \
	osgbrowser.1 \
	osgcallback.1 \
	osgcamera.1 \
	osgcatch.1 \
	osgclip.1 \
	osgcluster.1 \
	osgcompositeviewer.1 \
	osgcopy.1 \
	osgcubemap.1 \
	osgdelaunay.1 \
	osgdepthpartition.1 \
	osgdepthpeeling.1 \
	osgdistortion.1 \
	osgdrawinstanced.1 \
	osgfadetext.1 \
	osgfilecache.1 \
	osgfont.1 \
	osgforest.1 \
	osgfxbrowser.1 \
	osggameoflife.1 \
	osggeodemo.1 \
	osggeometry.1 \
	osggeometryshaders.1 \
	osghangglide.1 \
	osghud.1 \
	osgimagesequence.1 \
	osgimpostor.1 \
	osgintersection.1 \
	osgkdtree.1 \
	osgkeyboard.1 \
	osgkeyboardmouse.1 \
	osglauncher.1 \
	osglight.1 \
	osglightpoint.1 \
	osglogicop.1 \
	osglogo.1 \
	osgmanipulator.1 \
	osgmemorytest.1 \
	osgmotionblur.1 \
	osgmovie.1 \
	osgmultiplerendertargets.1 \
	osgmultitexture.1 \
	osgmultitexturecontrol.1 \
	osgoccluder.1 \
	osgocclusionquery.1 \
	osgpackeddepthstencil.1 \
	osgpagedlod.1 \
	osgparametric.1 \
	osgparticle.1 \
	osgparticleeffects.1 \
	osgpdf.1 \
	osgphotoalbum.1 \
	osgpick.1 \
	osgplanets.1 \
	osgpoints.1 \
	osgpointsprite.1 \
	osgprecipitation.1 \
	osgprerender.1 \
	osgprerendercubemap.1 \
	osgreflect.1 \
	osgrobot.1 \
	osgscalarbar.1 \
	osgscreencapture.1 \
	osgscribe.1 \
	osgsequence.1 \
	osgshaders.1 \
	osgshaderterrain.1 \
	osgshadow.1 \
	osgshape.1 \
	osgsharedarray.1 \
	osgsidebyside.1 \
	osgsimplifier.1 \
	osgsimulation.1 \
	osgslice.1 \
	osgspacewarp.1 \
	osgspheresegment.1 \
	osgspotlight.1 \
	osgstereoimage.1 \
	osgstereomatch.1 \
	osgteapot.1 \
	osgterrain.1 \
	osgtessellate.1 \
	osgtext.1 \
	osgtext3D.1 \
	osgtexture1D.1 \
	osgtexture2D.1 \
	osgtexture3D.1 \
	osgtexturerectangle.1 \
	osgthirdpersonview.1 \
	osgunittests.1 \
	osgvertexprogram.1 \
	osgviewerGLUT.1 \
	osgvolume.1 \
	osgwidgetaddremove.1 \
	osgwidgetbox.1 \
	osgwidgetcanvas.1 \
	osgwidgetframe.1 \
	osgwidgetinput.1 \
	osgwidgetlabel.1 \
	osgwidgetmenu.1 \
	osgwidgetmessagebox.1 \
	osgwidgetnotebook.1 \
	osgwidgetperformance.1 \
	osgwidgetscrolled.1 \
	osgwidgetshader.1 \
	osgwidgetstyled.1 \
	osgwidgettable.1 \
	osgwidgetwindow.1 \
	osgwindows.1 \
	osgQtBrowser.1 \
	osgQtWidgets.1 \
	osganalysis.1 \
	osganimationeasemotion.1 \
	osganimationmorph.1 \
	osgdatabaserevisions.1 \
	osgfpdepth.1 \
	osggpx.1 \
	osggraphicscost.1 \
	osgmultiviewpaging.1 \
	osgoit.1 \
	osgoutline.1 \
	osgparticleshader.1 \
	osgposter.1 \
	osgqfont.1 \
	osgshadercomposition.1 \
	osgshadergen.1 \
	osgtexturecompression.1 \
	osgthreadedterrain.1 \
	osguniformbuffer.1 \
	osguserstats.1 \
	osgvertexattributes.1 \
	osgviewerGTK.1 \
	osgviewerQtContext.1 \
	osgviewerSDL.1 \
	osgvirtualprogram.1 \
	present3D.1 \
	osguserdata.1 \
	osgviewerQt.1 \
	osgviewerWX.1

install-arch: build-arch
	dh_testdir
	dh_testroot

	# Add here commands to install the package into debian/tmp
	mkdir -p $(CURDIR)/debian/tmp/usr
	$(MAKE) -C build/osgstatic DESTDIR=$(CURDIR)/debian/tmp install
	$(MAKE) -C build/osg DESTDIR=$(CURDIR)/debian/tmp install
	-mv $(CURDIR)/debian/tmp/usr/share/OpenSceneGraph/bin/* $(CURDIR)/debian/tmp/usr/bin
	for man in ${MANEXAMPLES} ; do rm -f $$man ; ln -s debian/osgexamples.1 $$man ; done
	for man in ${MANAPPLICATIONS} ; do rm -f $$man ; ln -s debian/osgapplications.1 $$man ; done

# Build architecture-independent files here.
binary-indep: install-indep
	dh_installdocs -i
	dh_installchangelogs -i
	dh_install -i -XCMakeLists.txt
	dh_lintian -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

install-indep: build-indep
	mkdir -p debian/tmp/usr/share/openscenegraph/
	cp -r OpenSceneGraph/examples debian/tmp/usr/share/openscenegraph
